//+------------------------------------------------------------------+
//|                                                       .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property version   "1.00"            //     Low    
                                      //          
#property indicator_separate_window   //
#property indicator_buffers 3         //
#property indicator_color1 Magenta    //
#property indicator_color2 DodgerBlue //
#property indicator_color3 Yellow     //
#property indicator_width1 1          //
#property indicator_width2 1          //
#property indicator_width3 1          //
#property indicator_level1 0          //
//--- input parameters
  extern int       PERIOD = 15;       //
//--- buffers
  double buf_up[], buf_dn[],buf_sr[]; //
  double  ema_k0, ema_k1;             //
  int    work_period;                 //
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()                                 //
    {
   IndicatorShortName(StringConcatenate(     //
    "(", PERIOD, ")"));
   IndicatorDigits(4);                       //
   SetIndexBuffer(0,buf_sr);                 //
   SetIndexEmptyValue(0, -1);                //
   SetIndexLabel(0, "SR VOLUME");            //
   SetIndexBuffer(1,buf_dn);                 //
   SetIndexEmptyValue(1, -1);                //
   SetIndexLabel(1, "DN");                   //
   SetIndexBuffer(2,buf_up);                 //
   SetIndexEmptyValue(2, -1);                //
   SetIndexLabel(2, "UP");                   //
   ema_k0 = 2.0 / (PERIOD + 1);              //
   ema_k1 = 1.0 - ema_k0;                    //
   work_period = Bars - PERIOD - 2;          //
   return(0);
   }
   int start() {                                          //   
    int    i, j, left = Bars - IndicatorCounted() - 1;  //
    double u, d, sr;                                    //
    for(i = left; i >= 0; i--) {                        //
     if(i > work_period) {                              //
      buf_sr[i] = -1;                                   //
      buf_up[i] = -1;                                   //
      buf_dn[i] = -1;                                   //
    } else if(i == work_period) {                       //
      buf_sr[i] = 0;                                    //
      buf_up[i] = 0;                                    //
      buf_dn[i] = 0;                                    //
    for(j = Bars - 1; j >= i; j--) {                    //
      calc(j, u, d, sr);                                //
      buf_sr[i] += (u-d) * Volume[j] ;                   //
      buf_up[i] += u   * Volume[j] ;                     //
      buf_dn[i] += d   * Volume[j] ;                     //   
    }      
      buf_sr[i] /= PERIOD;                              //
      buf_up[i] /= PERIOD;                              //
      buf_dn[i] /= PERIOD;                              //
    } else {
      calc(i, u, d, sr);                                              //
      buf_sr[i] = buf_sr[i + 1]* ema_k1 + (u-d) * Volume[i] * ema_k0; //
      buf_up[i] = buf_up[i + 1] * ema_k1 + u   * Volume[i]  * ema_k0;  //
      buf_dn[i] = buf_dn[i + 1] * ema_k1 + d   * Volume[i]  * ema_k0;  //    
    }}         
      return(0); }        
   // ----  
   void calc(int bar, double &up, double &dn, double &sr) {    //
      if(High[bar] == Low[bar]) {                              //
      up = 0;dn = 0;sr = 0;                                    //
    return; }       
       double range = High[bar] - Low[bar];        //
       double path  =  (High[bar]- Close[bar]+0.707*(High[bar]- Close[bar]))/2;      //
       double zum = (range -path)/2 ;              //
      if(Close[bar] > Open[bar]) {                 //
       dn = 1.0 - (zum + path)/ range ;            //
       up = 1.0 - dn;                              //
       sr = up - dn;                               //
    } else {
       up = 1.0 - (zum + path)/ range ;            //
       dn = 1.0 - up;                              //
       sr = up - dn;                               //
      return; } }      
//+------------------------------------------------------------------+

